/**
   This program tests the Parse parser.

   The Parse parser is just a recognizing parser.
   It only determines if a string parses or not.
   The parser does not build a parse data structure.


*/

public class TestInfix1
{
   public static void main(String[] args)
   {
      String infix[] =
            // parenthesized infix notation
          { "sqrt 25",
            "2 + 3 * 4",
            "( 2 + 3 ) * 4",
            "2 - 3 + 4",
            "2 - ( 3 + 4 )",
            "4 / 2 / 2",
            "4 / ( 2 / 2 )",
            "-2 ^ 3",
            "( -2 ) ^ 3",
            "( - 2 ) ^ 3",

            "3 * sqrt 25 - ( - 6 + 5 ) * - 1",
            "- sqrt ( 6 ^ 2 ) + ( ( 4 ) * ( 2 ) )",

            "( 2 + 3 * 4 )",
            "( 2 + ( 3 * 4 ) )",
            "( ( 2 ) + ( 3 ) * ( 4 ) )",
            "( ( 2 ) + ( ( 3 ) * ( 4 ) ) )",

            "3 ^ 4  7 * 8",           // syntax error
            "3 ^ 4 * 7 +",            // syntax error (at +)
            "3 ^ 4 + ( 7 @ 8 )",      // syntax error (at @)
            "3 ^ 4 + 7 * x"           // syntax error (at x)
          };


      for (int i = 0; i < infix.length; i++)
      {
         try  // parse the expression
         {
            Parse.parse( infix[i] );
            System.out.println( infix[i] );
            System.out.println("Parsed OK.\n");
         }
         catch (ParseException e)
         {
            System.out.println( infix[i] );
            System.out.println(e + "\n");
          //e.printStackTrace();
         }
      }
   }//main()

}//TestInfix1
